#ifndef _akel_qsearch_h_
#define _akel_qsearch_h_
//---------------------------------------------------------------------------
#include <windows.h>
#include <richedit.h>
#include <TCHAR.h>
#include "AkelDllHeader.h"


/* >>>>>>>>>>>>>>>>>>>>>>>> plugin state >>>>>>>>>>>>>>>>>>>>>>>> */
    typedef struct tPluginState {
        BOOL         bInitialized;
        BOOL         bOldWindows;
        BOOL         bOldRichEdit; // TRUE means Rich Edit 2.0
        BOOL         bMDI;
        HINSTANCE    hInstanceDLL;
        HWND         hMainWnd;
        BOOL         bAkelPadOnFinish;
        LANGID       wLangSystem;
        WNDPROCDATA* pMainProcData;
        //WNDPROCDATA* pEditProcData;
        WNDPROCDATA* pFrameProcData;
    } PluginState;

    void initializePluginState(PluginState* pPlugin);
/* <<<<<<<<<<<<<<<<<<<<<<<< plugin state <<<<<<<<<<<<<<<<<<<<<<<< */


/* >>>>>>>>>>>>>>>>>>>>>>>> qsearch options >>>>>>>>>>>>>>>>>>>>>>>> */
    #define  OPTF_SRCH_ONTHEFLY_MODE     0
    #define  OPTF_SRCH_FROM_BEGINNING    1
    #define  OPTF_SRCH_USE_SPECIALCHARS  2
    #define  OPTF_SRCH_PICKUP_SELECTION  3
    #define  OPTF_SRCH_SELFIND_PICKUP    4
    #define  OPTF_SRCH_STOP_EOF          5    
    #define  OPTF_SRCH_WND_DOCKEDTOP     6
    #define  OPTF_EDIT_FOCUS_SELECTALL   7
    #define  OPTF_CATCH_MAIN_F3          8
    #define  OPTF_CATCH_MAIN_ESC         9
    #define  OPTF_HOTKEY_CLOSES_WND     10
    #define  OPTF_DOCK_RECT_DISABLED    11
    #define  OPTF_COUNT                 12

    #define  OPT_DOCK_RECT              12
    #define  OPT_COLOR_NOTFOUND         13
    #define  OPT_COLOR_EOF              14
    #define  OPT_COLOR_HIGHLIGHT        15
    #define  OPT_HIGHLIGHT_MARK_ID      16
    #define  OPT_HIGHLIGHT_STATE        17
    #define  OPT_USE_ALT_HOTKEYS        18
    #define  OPT_ALT_MATCHCASE          19
    #define  OPT_ALT_WHOLEWORD          20
    #define  OPT_ALT_HIGHLIGHTALL       21
    #define  OPT_TOTALCOUNT             22

    #define  HLS_IS_CHECKED              1
    #define  HLS_SET_ALWAYS             10
    
    typedef struct tQSearchOpt {
        DWORD    dwFlags[OPTF_COUNT];
        RECT     dockRect;
        COLORREF colorNotFound;
        COLORREF colorEOF;
        COLORREF colorHighlight;
        DWORD    dwHighlightMarkID;
        DWORD    dwHighlightState;
        DWORD    dwUseAltHotkeys;
        DWORD    dwAltMatchCase;
        DWORD    dwAltWholeWord;
        DWORD    dwAltHighlightAll;
    } QSearchOpt;

    void initializeOptions(QSearchOpt* pOptions);
    void copyOptions(QSearchOpt* pOptDst, const QSearchOpt* pOptSrc);
    BOOL equalOptions(const QSearchOpt* pOpt1, const QSearchOpt* pOpt2);
/* <<<<<<<<<<<<<<<<<<<<<<<< qsearch options <<<<<<<<<<<<<<<<<<<<<<<< */


// funcs
void  Initialize(PLUGINDATA* pd);
void  Uninitialize(void);


//---------------------------------------------------------------------------
#endif
